import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsComponents, CmsComponentsParam } from './model';


/**
 * 分页查询组件
 */
export async function pageCmsComponents(params: CmsComponentsParam) {
  const res = await request.get<ApiResult<PageResult<CmsComponents>>>(
    '/cms/cms-components/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询组件列表
 */
export async function listCmsComponents(params?: CmsComponentsParam) {
  const res = await request.get<ApiResult<CmsComponents[]>>(
    '/cms/cms-components',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加组件
 */
export async function addCmsComponents(data: CmsComponents) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-components',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改组件
 */
export async function updateCmsComponents(data: CmsComponents) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-components',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除组件
 */
export async function removeCmsComponents(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-components/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除组件
 */
export async function removeBatchCmsComponents(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-components/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询组件
 */
export async function getCmsComponents(id: number) {
  const res = await request.get<ApiResult<CmsComponents>>(
    '/cms/cms-components/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
